<?php
/*	lwrpage_manager : lower page manager
	name : lower page manager
	author: team1/3
	
*/

	global $html,$params,$database,$config,$ut,$plugin_ar;

	if (!isset($config)) { die(); }
	define('LWRM_ITEM_LIMIT',1000);
	
	draw();
	
	$params['rendering'] = false;

function draw()
{
	global $html,$params,$database,$ut;
	
	$page_ar = &$params['page'];
	$p_page = $page_ar['id'];

	if (check_rights('edit')) {
		snippet_breadcrumb($page_ar['link'], $page_ar['title']." - lower page manager");
		lwrpage_manager($page_ar);
	}
}

function lwrpage_manager( &$page_ar )
{
	global $params, $ut, $html, $database, $plugin_ar, $p_circle ;

	$id = $page_ar['id'];

	
	$ar = $database->sql_select_all("select id,metadata from ".DBX."data_items where type=? and id=? ", $page_ar['type'], $id);
	if ($ar) {
		$m = unserialize64($ar[0]['metadata']);
	}

$buff = <<<EOT
	<div style = 'background-color: #E8E8E8;'>
		<h2 style='margin: 0;padding: 10px 10px 0 10px;'>lower page manager v1.90</h2>
		<div style = 'padding: 0 0 20px 20px;'>
			<p>lower page manager, change metadata, template, etc</p>
		</div>
	</div>
EOT;
$buff .= <<<EOT
	<div class='edit_pointer'>
		<span onclick='ot.page_setting({$page_ar['id']})' title='Property' >{$ut->icon('setting')}</span> 
	</div>
EOT;
	$html['article'][] = frame_renderer($buff);

	if (!empty($_POST['mode']) && $_POST['mode'] == 'folder-systag') {
		
		$database->sql_begin();
		$params['folder-systag'] = true;
		$ar = $database->sql_select_all("select id from ".DBX."data_items where block_type !=5");
		foreach ($ar as $v) {
			regenerate_foldertag($v);
		}
		$params['circle']['meta']['folder_systag']=1;
		if ($database->sql_update( "update ".DBX."circles set metadata=? where id=?", serialize64($params['circle']['meta']), $p_circle)) {
		}
		$database->sql_commit();
	}
	
	if (empty($params['folder-systag']) && !isset($params['circle']['meta']['folder_systag'])) {
$buff = <<<EOT
		<div style = 'background-color: #FDEBD2;'>
			<h2 style='margin: 10px;padding: 10px 10px 0 10px;'>folder-systag warning</h2>
			<div style = 'padding: 0 0 20px 20px;'>
				<p>\$params['folder-systag'] option is not set</p>
				<ul>
					<li>lower page manager, change metadata, template, etc</li>
				</ul>
				<form method="post" action="{$_SERVER['REQUEST_URI']}" >
					<input type='hidden' name='xtoken' value='{$params['login_user']['meta']['magic_str']}' />
					<input type='hidden' name='mode' value='folder-systag' />
					<input type='submit' value='change data' class='onethird-button' />
				</form>
			</div>
		</div>
EOT;
		$html['article'][] = frame_renderer($buff);
	} else {
$buff = <<<EOT
		<div style = 'background-color: #E8E8E8;'>
			<div style = 'padding: 0 0 20px 20px;'>
				<form method="post" action="{$_SERVER['REQUEST_URI']}" >
					<input type='hidden' name='xtoken' value='{$params['login_user']['meta']['magic_str']}' />
					<input type='hidden' name='mode' value='folder-systag' />
					<input type='submit' value='regenerate folder-systag' class='onethird-button' />
				</form>
			</div>
		</div>
EOT;
		$html['article'][] = frame_renderer($buff);
	}

	$buff = draw_lwrpage_manager($arg);
	
	$html['article'][] = frame_renderer($buff);
	$html['article'][] = innerpage_renderer($page_ar['id']);

	return;
}

function get_lwrpage_manager_items(&$ar, $all_atr, $link, $type, $mode, $keyword, $template, $template_s, $template2, $template2_s, $metadata_entry)
{
	global $database;
	$arg = array();
	$arg[0] = "select id,metadata,type,mode,title from ".DBX."data_items where 1 ";
	if ($link && $link!==$all_atr) {
		$arg[] = array("and (link=? or tag like ?) ",$link,"%@dir:%{$link}_%");
	}
	if ($type !== $all_atr) {
		$arg[] = array(" and type=? ",$type);
	}
	if ($mode !== 'check_module' && $mode !== $all_atr) {
		$arg[] = array(" and mode=? ",$mode);
	}
	if ($keyword) {
		$arg[] = array(" and (title like ? or contents like ?)","%{$keyword}%","%{$keyword}%");
	}
	$arg[] = array(" limit ".LWRM_ITEM_LIMIT);
	$arx = $database->sql_select_all($arg);
	
	$ar = array();
	if ($mode === 'check_module') {
		foreach ($arx as $v) {
			$m = unserialize64($v['metadata']);
			$ok = true;
			if ($ok && !empty($m['template_ar']['php'])) {
				if (!is_array($m['template_ar']['php'])) {
					if (!check_template($m['template_ar']['php'])) {
						$ok = false;
						$m['module_error'][] = $m['template_ar']['php'];
					}
				} else {
					foreach ($m['template_ar']['php'] as $v) {
						if (!check_template($v)) {
							$ok = false;
							$m['module_error'][] = $v;
							break;
						}
					}
				}
			}
			if ($ok && !empty($m['template_ar']['tpl'])) {
				if (!is_array($m['template_ar']['tpl'])) {
					if (!check_template($m['template_ar']['tpl'])) {
						$ok = false;
						$m['module_error'][] = $m['template_ar']['tpl'];
					}
				} else {
					foreach ($m['template_ar']['tpl'] as $v) {
						if (!check_template($v)) {
							$ok = false;
							$m['module_error'][] = $v;
							break;
						}
					}
				}
			}
			if ($ok && !empty($m['lwr_template_ar']['php'])) {
				if (!is_array($m['lwr_template_ar']['php'])) {
					if (!check_template($m['lwr_template_ar']['php'])) {
						$ok = false;
						$m['module_error'][] = $m['lwr_template_ar']['php'];
					}
				} else {
					foreach ($m['lwr_template_ar']['php'] as $v) {
						if (!check_template($v)) {
							$ok = false;
							$m['module_error'][] = $v;
							break;
						}
					}
				}
			}
			if ($ok && !empty($m['lwr_template_ar']['tpl'])) {
				if (!is_array($m['lwr_template_ar']['tpl'])) {
					if (!check_template($m['lwr_template_ar']['tpl'])) {
						$ok = false;
					}
				} else {
					foreach ($m['lwr_template_ar']['tpl'] as $v) {
						if (!check_template($v)) {
							$ok = false;
							break;
						}
					}
				}
			}
			if (!$ok) {
				$v['meta'] = $m;
				unset($v['metadata']);
				$ar[] = $v;
			}
		}
		return;
	}
	
	if (!empty($arx)) {
		foreach ($arx as $v) {
			$m = unserialize64($v['metadata']);
			if (!empty($metadata_entry) && empty($m[$metadata_entry])) {
				continue;
			}
			if (!empty($template)) {
				if (empty($m['template_ar'])) {
					continue;
				}
				$x = '';
				foreach ($m['template_ar'] as $vv) {
					if ($x) { $x .= ','; }
					if (is_array($vv)) {
						$x = implode (',', $vv);
					} else {
						$x .= $vv;
					}
				}
				if ($template_s) {
					if ($x != $template) {
						continue;
					} 
				} else {
					if (strstr($x,$template) === false) {
						continue;
					}
				}
			}
			if (!empty($template2)) {
				if (empty($m['lwr_template_ar'])) {
					continue;
				}
				$x = '';
				foreach ($m['lwr_template_ar'] as $vv) {
					if ($x) { $x .= ','; }
					if (is_array($vv)) {
						$x = implode (',', $vv);
					} else {
						$x .= $vv;
					}
				}
				if ($template2_s) {
					if ($x != $template2) {
						continue;
					} 
				} else {
					if (strstr($x,$template2) === false) {
						continue;
					}
				}
			}
			$v['meta'] = $m;
			unset($v['metadata']);
			$ar[] = $v;
		}
	}
}

function check_template( $v )
{
	global $config,$p_circle;
	
	$path = $config['files_path'].DIRECTORY_SEPARATOR.$p_circle.DIRECTORY_SEPARATOR;
	if (substr($v,0,1) == '.') {
		$file = $path.'plugin'.DIRECTORY_SEPARATOR.substr($v,1);
	} else {
		$file = $path.'data'.DIRECTORY_SEPARATOR.$v;
	}
	return is_file($file);
}

function draw_lwrpage_manager( &$arg )
{
	global $params, $ut, $database, $html, $p_circle;


	if (!empty($_POST['delete'])) {
		
		$link = $params['page']['link'];
		$ar = array();
		get_linked_pages( $params['page']['id'], $ar );
		array_shift($ar);
		if (!remove_pages($ar)) {
			return false;
		}
		regenerate_attached( $params['page']['id'], true );
	}

	$all_atr = '(all)';
	$link = (int)$params['page']['id'];
	if (isset($_POST['lwrpage_manager_link'])) {
		$link = (int)$_POST['lwrpage_manager_link'];
	}
	$type = $all_atr;
	if (isset($_POST['lwrpage_manager_type']) && $_POST['lwrpage_manager_type'] && $_POST['lwrpage_manager_type'] !== $all_atr) {
		$type = (int)$_POST['lwrpage_manager_type'];
	}
	$mode = $all_atr;
	if (isset($_POST['lwrpage_manager_mode']) && $_POST['lwrpage_manager_mode'] !== $all_atr) {
		$mode = (int)$_POST['lwrpage_manager_mode'];
	}
	$keyword = '';
	if (isset($_POST['lwrpage_manager_keyword'])) {
		$keyword = sanitize_html($_POST['lwrpage_manager_keyword']);
	}
	$template = '';
	if (isset($_POST['lwrpage_manager_template'])) {
		$template = sanitize_str($_POST['lwrpage_manager_template']);
	}
	$template_s = false;
	if (isset($_POST['lwrpage_manager_template_s'])) {
		$template_s = true;
	}
	$template2 = '';
	if (isset($_POST['lwrpage_manager_template2'])) {
		$template2 = sanitize_str($_POST['lwrpage_manager_template2']);
	}
	$template2_s = false;
	if (isset($_POST['lwrpage_manager_template2_s'])) {
		$template2_s = true;
	}
	$metadata_entry = '';
	if (isset($_POST['lwrpage_manager_metadata'])) {
		$metadata_entry = sanitize_asc($_POST['lwrpage_manager_metadata']);
	}
	/*if (!empty($params['page']['meta']['template_ar']['php'])) {
		$template = implode(',',$params['page']['meta']['template_ar']['php']);
	}*/
	
	$change_value = "Change Value";
	$check_module = "Check Module";
	
	if (isset($_POST['submit']) && $_POST['submit'] == $change_value) {

		get_lwrpage_manager_items($ar, $all_atr, $link, $type, $mode, $keyword, $template, $template_s, $template2, $template2_s, $metadata_entry);

		$c = count($ar);

$buff = <<<EOT
		<div style = 'background-color: #FFE8E8;padding:20px;'>
			<input type='hidden' name='xtoken' value='{$params['login_user']['meta']['magic_str']}' />
			<h2 style="">Mod Data Items</h2>
			<p>count <span style='font-size:25px'>$c</span></p>
EOT;
			foreach ($ar as $v) {
$buff .= <<<EOT
				<p> #{$v['id']} - {$v['title']}  
EOT;
				$arg = array();
				$m = $v['meta'];
				$arg[0] = "update ".DBX."data_items set ";
				
				if ($_POST['lwrpage_manager_new_meta_key'] != '') {
					$buff .= ',meta_key';
					$key = sanitize_asc($_POST['lwrpage_manager_new_meta_key']);
					$val = sanitize_str($_POST['lwrpage_manager_new_meta_value']);
					if ($_POST['lwrpage_manager_new_meta_value'] == 'null') {
						unset($m[$key]);
						$buff .= ",$key clear";
					} else {
						$buff .= ",$key set";
						$m[$key] = $val;
					}
				}
				if ($_POST['lwrpage_manager_new_template'] != '') {
					if ($_POST['lwrpage_manager_new_template'] == 'null') {
						unset($m['template_ar']);
						$buff .= ',template clear';
					} else {
						$x = explode(',',sanitize_str($_POST['lwrpage_manager_new_template']));
						foreach ($x as $vv) {
							$op = '+';
							if (substr($vv,0,1) == '+') {
								$vv = substr($vv,1);
							} else if (substr($vv,0,1) == '-') {
								$op = '-';
								$vv = substr($vv,1);
								$buff .= ',template -'.$vv;
							}
							if (substr($vv,-4) == '.php') {
								$az = $m['template_ar']['php'];
								if (!is_array($az)) {
									if (empty($az)) {
										$az = array();
									} else {
										$az = array($az);
									}
								}
								$m['template_ar']['php'] = array();
								foreach ($az as $vvv) {
									if ($vv != $vvv) {
										$m['template_ar']['php'][] = $vvv;
									}
								}
								if ($op == '+') { $m['template_ar']['php'][] = $vv; $buff .= ',template +'.$vv; }
							} else if (substr($vv,-4) == '.tpl') {
								$m['template_ar']['tpl'] = $vv; $buff .= ',template='.$vv;
							}
						}
					}
				}
				if ($_POST['lwrpage_manager_new_template2'] != '') {
					if ($_POST['lwrpage_manager_new_template2'] == 'null') {
						unset($m['lwr_template_ar']);
						$buff .= ',template clear';
					} else {
						$x = explode(',',sanitize_str($_POST['lwrpage_manager_new_template2']));
						foreach ($x as $vv) {
							$op = '+';
							if (substr($vv,0,1) == '+') {
								$vv = substr($vv,1);
							} else if (substr($vv,0,1) == '-') {
								$op = '-';
								$vv = substr($vv,1);
								$buff .= ',template -'.$vv;
							}
							if (substr($vv,-4) == '.php') {
								$az = $m['lwr_template_ar']['php'];
								$m['lwr_template_ar']['php'] = array();
								foreach ($az as $vvv) {
									if ($vv != $vvv) {
										$m['lwr_template_ar']['php'][] = $vvv;
									}
								}
								if ($op == '+') { $m['lwr_template_ar']['php'][] = $vv; $buff .= ',template +'.$vv; }
							} else if (substr($vv,-4) == '.tpl') {
								$m['lwr_template_ar']['tpl'] = $vv;  $buff .= ',template='.$vv;
							}
						}
					}
				}
				if ($_POST['lwrpage_manager_new_format'] != '') {
					$buff .= ',format';
					$x = sanitize_html($_POST['lwrpage_manager_new_format']);
					$m['format'] = $x;
				}

				$arg[0] .= "  metadata=? ";
				$arg[] = serialize64($m);

				if ($_POST['lwrpage_manager_new_type'] != '') {
					$buff .= ',type';
					$arg[0] .= " , type=? ";
					$arg[] = (int)$_POST['lwrpage_manager_new_type'];
				}
				if ($_POST['lwrpage_manager_new_mode'] != '') {
					$buff .= ',mode';
					$arg[0] .= " , mode=? ";
					$arg[] = (int)$_POST['lwrpage_manager_new_mode'];
				}
				if ($_POST['lwrpage_manager_new_contents'] != '') {
					$buff .= ',contents';
					$arg[0] .= " , contents=? ";
					$arg[] = sanitize_html($_POST['lwrpage_manager_new_contents']);
				}
				
				$arg[0] .= "  where id=? ";
				$arg[] = $v['id'];
				
				if (!call_user_func_array(array($database, "sql_update"), $arg)) {
					$buff .= ' ... error';
				} else {
					$buff .= ' ... ok';
				}

				if (!empty($_POST['lwrpage_manager_replace_value1'])) {
					$buff .= ' , replace ';
					if (read_pagedata($v['id'], $tx)) {
						$tx['contents'] = str_replace($_POST['lwrpage_manager_replace_value1'],sanitize_html($_POST['lwrpage_manager_replace_value2']),$tx['contents']);
						if (mod_data_items($tx)) {
							$buff .= ' ... ok';
						} else {
							$buff .= ' ... error';
						}
					}
				}

$buff .= <<<EOT
				</p>
EOT;
			}

$buff .= <<<EOT
		</div>
EOT;
		$html['article'][] = frame_renderer($buff);
	}
	
	if (isset($_POST['submit']) && $_POST['submit'] == $check_module) {

		get_lwrpage_manager_items($ar, $all_atr, $link, $type, "check_module", $keyword, $template, $template_s, $template2, $template2_s, $metadata_entry);

		$c = count($ar);
 
$buff = <<<EOT
		<div style = 'background-color: #FFE8E8;padding:20px;'>
			<input type='hidden' name='xtoken' value='{$params['login_user']['meta']['magic_str']}' />
			<h2>Template Module Error</h2>
			<p>count <span style='font-size:25px'>$c</span></p>
EOT;
			foreach ($ar as $v) {
				$e = implode(',',$v['meta']['module_error']);
$buff .= <<<EOT
				<p> #{$v['id']} - 
					<a href='{$ut->link($v['id'])}'>{$v['title']} ($e)</a>
					<a href='javascript:void(ot.page_setting({$v['id']}))'>{$ut->icon('setting')}</a>
				</p>
EOT;
			}

$buff .= <<<EOT
		</div>
EOT;
		$html['article'][] = frame_renderer($buff);
	}

$buff = <<<EOT
	<form method="post" action="{$_SERVER['REQUEST_URI']}" style = 'background-color: #E8E8E8; padding-left:20px;'>
		<input type='hidden' name='xtoken' value='{$params['login_user']['meta']['magic_str']}' />
		<h2 style="margin: 10px;padding: 10px 10px 0 10px;">Filter</h2>
		<table class='onethird-setting'>
			<tr>
				<td style='vertical-align: top;'>link</td>
				<td>
					<input type='text' name='lwrpage_manager_link' value='$link' style='width:5em' />
				</td>
				<td style='vertical-align: top;'>type</td>
				<td>
					<input type='text' name='lwrpage_manager_type' value='$type' style='width:5em' />
				</td>
				<td style='vertical-align: top;'>mode</td>
				<td>
					<input type='text' name='lwrpage_manager_mode' value='$mode' style='width:5em' />
				</td>
			</tr>
			<tr>
				<td style='vertical-align: top;'>free keyword</td>
				<td colspan=5>
					<input type='text' name='lwrpage_manager_keyword' value='$keyword' />
				</td>
			</tr>
			<tr>
				<td style='vertical-align: top;'>metadata entry</td>
				<td colspan=5>
					<input type='text' name='lwrpage_manager_metadata' value='$metadata_entry' />
				</td>
			</tr>
			<tr>
				<td style='vertical-align: top;'>template</td>
				<td colspan=5>
					<input type='text' name='lwrpage_manager_template' value='$template' />
					<label>
						<input type='checkbox' name='lwrpage_manager_template_s' {$ut->check($template_s,' checked ')} />
						same template
					</label>
				</td>
			</tr>
			<tr>
				<td style='vertical-align: top;'>lwr_template</td>
				<td colspan=5>
					<input type='text' name='lwrpage_manager_template2' value='$template2' />
					<label>
						<input type='checkbox' name='lwrpage_manager_template2_s' {$ut->check($template2_s,' checked ')} />
						same template
					</label>
				</td>
			</tr>
			<tr>
				<td style='vertical-align: top;'></td>
				<td>
					<input type='submit' value='apply filter' name='submit' />
					<input type='submit' value='$check_module' name='submit' />
				</td>
			</tr>
		</table>
EOT;
		
		get_lwrpage_manager_items($ar, $all_atr, $link, $type, $mode, $keyword, $template, $template_s, $template2, $template2_s, $metadata_entry);
		$c = 0;
		if ($ar)  {
			$c = count($ar);
		}

$buff .= <<<EOT
		<h2 style="margin: 10px;padding: 10px 10px 0 10px;">The number of data to be changed</h2>
		<span style='font-size:25px;margin-left: 58px;' >$c</span>
		<div style='max-height: 300px; overflow-y: scroll;margin-left: 58px;'>
EOT;
			for ($i = 0; $i < count($ar) && $i < LWRM_ITEM_LIMIT; ++$i) {
				$buff .= "<a href='{$ut->link($ar[$i]['id'])}'>#{$ar[$i]['id']} - {$ar[$i]['title']}</a><br />";
			}
$buff .= <<<EOT
		</div>
		<h2 style="margin: 10px;padding: 10px 10px 0 10px;">New Value</h2>
		<table class='onethird-setting'>
			<tr>
				<td style='vertical-align: top;'>type</td>
				<td>
					<input type='text' name='lwrpage_manager_new_type' />
				</td>
				<td style='vertical-align: top;'>mode</td>
				<td>
					<input type='text' name='lwrpage_manager_new_mode' />
				</td>
			</tr>
			<tr>
				<td style='vertical-align: top;'>meta key</td>
				<td>
					<input type='text' name='lwrpage_manager_new_meta_key' />
				</td>
				<td style='vertical-align: top;'>value</td>
				<td>
					<input type='text' name='lwrpage_manager_new_meta_value' />
				</td>
			</tr>
			<tr>
				<td style='vertical-align: top;'>template</td>
				<td colspan='3'>
					<textarea name='lwrpage_manager_new_template' ></textarea>
					ex) +???.php,-???.php,???.tpl * null for all clear, 
				</td>
			</tr>
			<tr>
				<td style='vertical-align: top;'>lwr template</td>
				<td colspan='3'>
					<textarea name='lwrpage_manager_new_template2' ></textarea>
					ex) +???.php,-???.php,???.tpl * null for all clear, 
				</td>
			</tr>
			<tr>
				<td style='vertical-align: top;'>format</td>
				<td colspan='3'>
					<textarea name='lwrpage_manager_new_format' ></textarea>
				</td>
			</tr>
			<tr>
				<td style='vertical-align: top;'>contents</td>
				<td colspan='3'>
					<textarea name='lwrpage_manager_new_contents' ></textarea>
				</td>
			</tr>
			<tr>
				<td style='vertical-align: top;'>replace contents</td>
				<td >
					<input type='text' name='lwrpage_manager_replace_value1' />
				</td>
				<td >
					⇒
				</td>
				<td >
					<input type='text' name='lwrpage_manager_replace_value2' />
				</td>
			</tr>
			<tr>
				<td style='vertical-align: top;'></td>
				<td>
					<input type='submit' value='$change_value' name='submit' />
				</td>
			</tr>
		</table>
		<br />
	</form>
EOT;
	
	$html['article'][] = frame_renderer($buff);

}


?>